EEWRITE_	MACRO	EEDATA_, EEADR_, GIE_OFF
; provede zapis do EEPROM pameti
; - EEDATA_ (promenna) obsahuje data k zapsani
; - EEADR_ (promenna) obsahuje adresu, kam se maji data zapsat
; - GIE_OFF urcuje, zda se ma program starat o zakazani preruseni
;           jednicka rika, ze ano

	banksel	EECON1	; nejprve pockame na ukonceni posledniho zapisu
	BTFSC	EECON1,WR
	GOTO	$ - 1
	banksel	EEDATA_	; potom zaplnime registry EEDATA a EEADR
	MOVF	EEDATA_,W
	banksel	EEDATA
	MOVWF	EEDATA
	banksel	EEADR_
	MOVF	EEADR_,W
	banksel	EEADR
	MOVWF	EEADR
	banksel	EECON1
	BCF	EECON1,EEPGD	; nyni zahajime zapis
	BSF	EECON1,WREN
	IF GIE_OFF==1
	BCF	INTCON,GIE	; pripadne zakazeme preruseni
	BTFSC	INTCON,GIE
	GOTO	$ - 2
	ENDIF
	MOVLW	H'55'
	MOVWF	EECON2
	MOVLW	H'AA'
	MOVWF	EECON2
	BSF	EECON1,WR
	IF GIE_OFF==1
	BSF	INTCON,GIE	; pripadne povolime preruseni
	ENDIF
	BCF	EECON1,WREN
	banksel	D'0'

	ENDM

EEREAD_	MACRO
; provede cteni z EEPROM
; - nejsou vyzadovany zadne parametry vstupem i vystupem je pracovni registr W

	banksel	EECON1	; pockame na ukonceni posledniho zapisu
	BTFSC	EECON1,WR
	GOTO	$ - 1
	banksel	EEADR	; W ulozime do EEADR
	MOVWF	EEADR
	banksel	EECON1
	BCF	EECON1,EEPGD
	BSF	EECON1,RD	; zahajime cteni
	banksel	EEDATA
	MOVF	EEDATA,W	; do W ulozime prectena data
	banksel	D'0'

	ENDM	

FWRITE_	MACRO	EEDATA_, EEADR_, GIE_OFF, ZAVADEC
; provede zapis do FLASH pameti
; - EEDATA_ (promenna) data k ulozeni do FLASH (2 byty)
; - EEADR_ (promenna) adresa, kam se maji data ulozit (2 byty)
; - GIE_OFF urcuje, zda se ma program starat o zakazani preruseni
;           jednicka rika, ze ano
; - ZAVADEC rika, zda se ma chranit cast pameti, ktera obsahuje zavadec
;           pokud je zde jednicka, potom je ochrana aktivni.

	LOCAL	SKOK, KONEC

	banksel	EECON1	; pockame na ukonceni posledniho zapisu do EEPROM
	BTFSC	EECON1,WR
	GOTO	$ - 1

	IF ZAVADEC==1	; alternativni ochrana zavadece
	banksel	EEADR_
	MOVF	EEADR_,W
	ANDLW	B'00011110'
	XORLW	B'00011110'
	BTFSC	STATUS,Z
	GOTO	KONEC
	MOVF	EEADR_+1,W
	ANDLW	B'00011111'
	BTFSS	STATUS,Z
	GOTO	SKOK
	MOVLW	D'3'
	SUBWF	EEADR_,W
	BTFSS	STATUS,C
	GOTO	KONEC
	ENDIF	

SKOK
	banksel	EEDATA_	; zaplni se EEDATA, EEDATH, EEADR a EEADRH
	MOVF	EEDATA_,W
	banksel	EEDATA
	MOVWF	EEDATA
	banksel	EEDATA_+1
	MOVF	EEDATA_+1,W
	banksel	EEDATH
	MOVWF	EEDATH
	banksel	EEADR_
	MOVF	EEADR_,W
	banksel	EEADR
	MOVWF	EEADR
	banksel	EEADR_+1
	MOVF	EEADR_+1,W
	banksel	EEADRH
	MOVWF	EEADRH

	banksel	EECON1	; zahajuje se zapis
	BSF	EECON1,EEPGD
	BSF	EECON1,WREN
	IF GIE_OFF==1	; pripadne zakazeme preruseni
	BCF	INTCON,GIE
	BTFSC	INTCON,GIE
	GOTO	$ - 2
	ENDIF
	MOVLW	H'55'
	MOVWF	EECON2
	MOVLW	H'AA'
	MOVWF	EECON2
	BSF	EECON1,WR
	NOP
	NOP
	IF GIE_OFF==1
	BSF	INTCON,GIE	; pripadne opet povolime preruseni
	ENDIF
	BCF	EECON1,WREN
KONEC
	banksel	D'0'

	ENDM

FREAD_	MACRO	EEDATA_, EEADR_
; provede cteni z FLASH pameti
; - EEDATA_ (promenna) sem se ulozi prectena data (2 byty)
; - EEADR_ (promenna) adresa, ze ktere se ma cist (2 byty)

	banksel	EECON1	; pockame na ukonceni posledniho zapisu do EEPROM
	BTFSC	EECON1,WR
	GOTO	$ - 1
	banksel	EEADR_	; zaplnime EEADR a EEADRH
	MOVF	EEADR_,W
	banksel	EEADR
	MOVWF	EEADR
	banksel	EEADR_+1
	MOVF	EEADR_+1,W
	banksel	EEADRH
	MOVWF	EEADRH
	banksel	EECON1
	BSF	EECON1,EEPGD	; zahajeni cteni
	BSF	EECON1,RD
	NOP
	NOP
	banksel	EEDATA	; vysledek presuneme do EEDATA a EEDATA+1
	MOVF	EEDATA,W
	banksel	EEDATA_
	MOVWF	EEDATA_
	banksel	EEDATH
	MOVF	EEDATH,W
	banksel	EEDATA_+1
	MOVWF	EEDATA_+1
	banksel	D'0'

	ENDM
