	LIST	P = 16F877, R = DEC
	#include	p16f877.inc

	__CONFIG	B'11111100111010'

	#include	buffer.inc
	#include	znaky.inc
	#include	displej.inc
	#include	key_int3.inc

;---------------------------------------------
;||||||||||| KONSTANTY PROGRAMU ||||||||||||||
;---------------------------------------------

#DEFINE	DB4	PORTE,2		; PINY PRO OVLADANI DISPLEJE
#DEFINE	DB5	PORTE,1
#DEFINE	DB6	PORTE,0
#DEFINE	DB7	PORTA,4
#DEFINE	E	PORTB,1
#DEFINE	RW	PORTB,2
#DEFINE	RS	PORTB,3

TXBSIZE	EQU	16
RCBSIZE	EQU	16

OFFRAM	EQU	H'20'		; ZACATEK VOLNE PAMETI "RAM"
TEMPRAM	EQU	H'70'

	CBLOCK	OFFRAM
	TMH:1
	TML:1
	DDATA:1
	TXUIN:1
	TXUOUT:1
	TXBSTAT:1
	TXTEMP:1
	TXBADR:TXBSIZE
	KB:2
	K_OUT:2
	KROK:1
	KEYTEMP:1
	K_STATUS:1
	N_KLAV:2
	S_KLAV:2
	K_CAS1:1
	ENDC
	
	CBLOCK	TEMPRAM
	W_TEMP:1
	ST_TEMP:1
	FSR_TEMP:1
	ENDC

	ORG	0
	NOP
	NOP
	NOP
	GOTO	START

	ORG	4
	MOVWF	W_TEMP
	MOVF	STATUS,W
	MOVWF	ST_TEMP
	MOVF	FSR,W
	MOVWF	FSR_TEMP

	TXBUFF_I	TXBADR, TXBSIZE, TXUIN, TXUOUT, TXBSTAT

	KEY_IPROG	PIR1, TMR2IF, PORTD, KB, K_OUT, KROK, KEYTEMP, K_STATUS, S_KLAV, K_CAS1, D'50'

	MOVF	FSR_TEMP,W
	MOVWF	FSR
	MOVF	ST_TEMP,W
	MOVWF	STATUS
	SWAPF	W_TEMP,F
	SWAPF	W_TEMP,W
	RETFIE

START	MOVLW	B'00100100'	; nastav vysilac pro...
	banksel	TXSTA		; ...asynchronni 8bitovy prenos
	MOVWF	TXSTA
	MOVLW	B'10010000'	; nastav prijimac pro...
	banksel	RCSTA		; ...asynchronni 8bitovy prijem
	MOVWF	RCSTA
	MOVLW	D'64'		; nastav komunikacni rychlost,...
	banksel	SPBRG		; ...v nasem pripade 19200 baudu
	MOVWF	SPBRG
	banksel	ADCON1
	MOVLW	B'00000110'	; nastav PORTA jako "logicky"
	MOVWF	ADCON1
	banksel	0

	TXBUFFINI	TXUIN, TXUOUT, TXBSTAT

	MOVLW	B'00000101'
	MOVWF	T2CON

	KEY_INIT	PIR1, TMR2IE, TMR2IF, PORTD, KB, K_OUT, KROK, K_STATUS, K_CAS1, S_KLAV

	CALL	INITDISP

	MOVLW	D'4'
	CALL	SETPOS
	MOVLW	ZNAK_D
	CALL	PUTZNAK
	MOVLW	ZNAK_E
	CALL	PUTZNAK
	MOVLW	ZNAK_T
	CALL	PUTZNAK
	MOVLW	ZNAK_E
	CALL	PUTZNAK
	MOVLW	ZNAK_K
	CALL	PUTZNAK
	MOVLW	ZNAK_C
	CALL	PUTZNAK
	MOVLW	ZNAK_E
	CALL	PUTZNAK

	MOVLW	D'64'+3
	CALL	SETPOS
	MOVLW	ZNAK_S
	CALL	PUTZNAK
	MOVLW	ZNAK_T
	CALL	PUTZNAK
	MOVLW	ZNAK_I
	CALL	PUTZNAK
	MOVLW	ZNAK_S
	CALL	PUTZNAK
	MOVLW	ZNAK_K
	CALL	PUTZNAK
	MOVLW	ZNAK_N
	CALL	PUTZNAK
	MOVLW	ZNAK_U
	CALL	PUTZNAK
	MOVLW	ZNAK_T
	CALL	PUTZNAK
	MOVLW	ZNAK_I
	CALL	PUTZNAK

	BSF	INTCON,PEIE
	BSF	INTCON,GIE

LOOP	BTFSS	K_STATUS,1
	GOTO	LOOP
	BCF	K_STATUS,1
NEXT	MOVLW	D'133'		; synchronizacni (uvodni) byte
	CALL	PUTBYTE		; ...poslat do bufferu
	BCF	INTCON,GIE	; zablokovani systemu preruseni
	BTFSC	INTCON,GIE
	GOTO	$ - 2
	MOVF	K_OUT,W		; stav klavesnice je poslan do bufferu
	CALL	PUTBYTE
	MOVF	K_OUT+1,W
	CALL	PUTBYTE

	CLRF	K_OUT
	CLRF	K_OUT+1

	BSF	INTCON,GIE	; system preruseni je obnoven
	MOVLW	D'33'		; synchroniyacni (koncovy) byte
	CALL	PUTBYTE
	GOTO	LOOP		; opakuj cyklus

PUTBYTE	TXBUFF_P	TXBADR, TXBSIZE, TXUIN, TXUOUT, TXBSTAT, TXTEMP

	DISPLEJ	TMH,TML,DDATA,DB4,DB5,DB6,DB7,E,RW,RS

	END
