; OBSLUHA BUFFERU

; poznamka - symbol (*) znaci, ze velicina je pouze adresou promenne

; inicializace bufferu pro zapis (vystupni buffer)
TXBUFFINI MACRO	UKAZIN,UKAZOUT,BUFFSTAT
; UKAZIN* - vstupni ukazatel
; UKAZOUT* - vystupni ukazatel
; BUFFSTAT* - indikator poctu znaku v bufferu
	CLRF	UKAZIN
	CLRF	UKAZOUT
	CLRF	BUFFSTAT
	ENDM

; inicializace bufferu pro cteni (vstupni buffer)
RCBUFFINI	MACRO	UKAZIN, UKAZOUT, BUFFSTAT, BFLAGS
; UKAZIN* - vstupni ukazatel
; UKAZOUT* - vystupni ukazatel
; BUFFSTAT* - indikator poctu znaku v bufferu
; BFLAGS* - chybove priznaky
	CLRF	UKAZIN
	CLRF	UKAZOUT
	CLRF	BUFFSTAT
	CLRF	BFLAGS
	banksel	PIE1	; povoleni preruseni od RCIF
	BSF	PIE1,RCIE
	banksel	0
	ENDM

; vyslani znaku z vystupniho bufferu na seriovy port
TXBUFF_I	MACRO	BUFFADR, BUFFSIZE, UKAZIN, UKAZOUT, BUFFSTAT
; BUFFADR - adresa zacatku bufferu
; BUFFSIZE - velikost bufferu
; UKAZIN* - vstupni ukazatel
; UKAZOUT* - vystupni ukazatel
; BUFFSTAT* - indikator poctu znaku v bufferu

	LOCAL	KONEC, PRAZDNO

	banksel	PIR1
	BTFSS	PIR1,TXIF		; kontrola priznaku preruseni
	GOTO	KONEC
	MOVF	BUFFSTAT,W	; kontrola obsahu bufferu
	BTFSC	STATUS,Z
	GOTO	PRAZDNO
	bankisel	BUFFADR		; nastaveni ukazatele
	MOVLW	BUFFADR
	ADDWF	UKAZOUT,W
	MOVWF	FSR
	MOVF	INDF,W		; precteni znaku z bufferu...
	banksel	TXREG		; ... a zapsani na seriovy port
	MOVWF	TXREG
	INCF	UKAZOUT,F		; posun ukazatele...
	MOVLW	BUFFSIZE		; ... a hlidani jeho horni hranice
	SUBWF	UKAZOUT,W
	BTFSC	STATUS,C
	CLRF	UKAZOUT
	DECF	BUFFSTAT,F	; v bufferu je o jeden znak mene
	GOTO	KONEC		; konec obsluhy !!!
PRAZDNO
	banksel	PIE1		; pokud je buffer prazdny...
	BCF	PIE1,TXIE		; ... zakazeme preruseni od TXIF
KONEC
	ENDM


; precteni znaku ze serioveho portu a ulozeni do vstupniho bufferu
RCBUFF_I	MACRO	BUFFADR, BUFFSIZE, UKAZIN, UKAZOUT, BUFFSTAT, BFLAGS
; BUFFADR - adresa zacatku bufferu
; BUFFSIZE - velikost bufferu
; UKAZIN* - vstupni ukazatel
; UKAZOUT* - vystupni ukazatel
; BUFFSTAT* - indikator poctu znaku v bufferu
; BFALGS* - chybove priznaky

	LOCAL	KONEC,PLNO,CHYBA

	BTFSS	PIR1,RCIF		; kontrola priznaku preruseni
	GOTO	KONEC

	MOVLW	BUFFSIZE		; kontrola obsahu bufferu
	SUBWF	BUFFSTAT,W
	BTFSC	STATUS,C
	GOTO	PLNO

	bankisel	BUFFADR		; nastaveni ukazatele
	MOVLW	BUFFADR
	ADDWF	UKAZIN,W
	MOVWF	FSR
	BTFSC	RCSTA,FERR	; kontrola chyby prenosu
	GOTO	CHYBA		;  pokud nastane chyba, prijaty znak je zrusen
	BTFSC	RCSTA,OERR	; kontrola chyby preteceni
	GOTO	CHYBA		;  pokud nastane chyba, seriovy port je resetovan
	MOVF	RCREG,W		; precteni znaku z portu...
	MOVWF	INDF		; ... a ulozeni do bufferu
	banksel	UKAZIN		; posun ukazatele...
	INCF	UKAZIN,F
	MOVLW	BUFFSIZE		; ...a kontrola jeho horni hranice
	SUBWF	UKAZIN,W
	BTFSC	STATUS,C
	CLRF	UKAZIN
	INCF	BUFFSTAT,F	; v bufferu je o jeden znak vice
	GOTO	KONEC		; konec obsluhy !!!
PLNO	BSF	BFLAGS,0		; pokud byl buffer preplnen, nastavime chybovy priznak...
	BTFSC	RCSTA,FERR	; ...a prijaty znak stornujeme...
	GOTO	CHYBA		; ...vcetne osetreni chyb
	BTFSC	RCSTA,OERR
	GOTO	CHYBA
	MOVF	RCREG,W
	GOTO	KONEC
CHYBA	BSF	BFLAGS,1		; osetreni chybovych priznaku
	MOVF	RCREG,W
	BTFSS	RCSTA,OERR
	GOTO	KONEC
	BSF	BFLAGS,2
	BCF	RCSTA,CREN
	BSF	RCSTA,CREN
KONEC

	ENDM


; ulozeni znaku do vystupniho bufferu
TXBUFF_P	MACRO	BUFFADR, BUFFSIZE, UKAZIN, UKAZOUT, BUFFSTAT, TEMP
; BUFFADR - adresa zacatku bufferu
; BUFFSIZE - velikost bufferu
; UKAZIN* - vstupni ukazatel
; UKAZOUT* - vystupni ukazatel
; BUFFSTAT* - indikator poctu znaku v bufferu
; TEMP* - pomocna promenna

	MOVWF	TEMP		; ulozeni vstupu do pomocne promenne

	MOVLW	BUFFSIZE		; kontrola obsahu bufferu
	SUBWF	BUFFSTAT,W
	BTFSC	STATUS,C
	RETURN

	BCF	INTCON,GIE	; zablokovani systemu preruseni
	BTFSC	INTCON,GIE
	GOTO	$ - 2

	bankisel	BUFFADR		; nastaveni ukazatele
	MOVLW	BUFFADR
	ADDWF	UKAZIN,W
	MOVWF	FSR
	MOVF	TEMP,W		; zapsani znaku do bufferu
	MOVWF	INDF
	banksel	BUFFSTAT
	INCF	UKAZIN,F		; posun ukazatele
	MOVLW	BUFFSIZE
	SUBWF	UKAZIN,W
	BTFSC	STATUS,C
	CLRF	UKAZIN
	INCF	BUFFSTAT,F	; v bufferu je o jeden znak vice
	banksel	PIE1
	BSF	PIE1,TXIE		; povoleni preruseni od TXIF
	banksel	0
	BSF	INTCON,GIE	; obnoveni celkoveho systemu preruseni
	RETURN

	ENDM

RCBUFF_P	MACRO	BUFFADR, BUFFSIZE, UKAZIN, UKAZOUT, BUFFSTAT, TEMP
; BUFFADR - adresa zacatku bufferu
; BUFFSIZE - velikost bufferu
; UKAZIN* - vstupni ukazatel
; UKAZOUT* - vystupni ukazatel
; BUFFSTAT* - indikator poctu znaku v bufferu
; TEMP* - pomocna promenna

	MOVF	BUFFSTAT,F	; kontrola obsahu bufferu
	BTFSC	STATUS,Z	
	RETURN

	BCF	INTCON,GIE	; zablokovani systemu preruseni
	BTFSC	INTCON,GIE
	GOTO	$ - 2

	bankisel	BUFFADR		; nastaveni ukazatele
	MOVLW	BUFFADR
	ADDWF	UKAZOUT,W
	MOVWF	FSR
	MOVF	INDF,W		; precteni znaku z bufferu...
	banksel	TEMP
	MOVWF	TEMP		; ... a ulozeni do pomocne promenne
	INCF	UKAZOUT,F		; posun ukazatele
	MOVLW	BUFFSIZE
	SUBWF	UKAZOUT,W
	BTFSC	STATUS,C
	CLRF	UKAZOUT
	DECF	BUFFSTAT,F	; v bufferu je o jeden znak mene
	MOVF	TEMP,W		; zkopirovani pomocne promenne do W
	BSF	INTCON,GIE	; obnoveni celkoveho systemu preruseni
	RETURN	

	ENDM
